#include <amxmodx>
#include <fun>
#include <hamsandwich>

#define Ham_Player_ResetMaxSpeed Ham_Item_PreFrame

//comment out not to use sound
#define USE_SOUND

new const g_name_prefix[] = "===>[Super]<==="

new g_super_player
new gSound[] = "misc/strength.wav"

new pcvarHealth
new pcvarArmor
new pcvarSpeed
new pcvarGrav
new pcvarPrefix
new pcvarAnnounce
new pcvarGiveHE
new pcvarGiveSmoke
new pcvarGiveFlash
new pcvarHeal
new pcvarHealPoints

public plugin_init()
{
	//Credit to Exolent for fixing the code!
	register_plugin("Random Super Player", "1.6", "Jelle")
	
	pcvarHealth = register_cvar("super_health", "250")
	pcvarArmor = register_cvar("super_armor", "200")
	pcvarSpeed = register_cvar("super_speed", "350.0")
	pcvarGrav = register_cvar("super_gravity", "0.5")
	pcvarPrefix = register_cvar("super_prefix", "1")
	pcvarAnnounce = register_cvar("super_announce", "1")
	pcvarGiveHE = register_cvar("super_givehe", "1")
	pcvarGiveFlash = register_cvar("super_giveflash", "2")
	pcvarGiveSmoke = register_cvar("super_givesmoke", "0")
	pcvarHeal = register_cvar("super_heal", "0")
	pcvarHealPoints = register_cvar("super_healpoints", "50")
	
	register_logevent("EventRoundStart", 2, "1=Round_Start")
	register_logevent("EventRoundEnd", 2, "1=Round_End")
	register_event("TextMsg", "EventRoundEnd", "a", "2&#Game_C", "2&#Game_w")
	register_event("DeathMsg", "super_death", "a", "1>0")
	
	RegisterHam(Ham_Player_ResetMaxSpeed, "player", "FwdPlayerResetMaxSpeedPost", 1)
}

#if defined USE_SOUND
public plugin_precache()
{
	precache_sound(gSound)
}
#endif

public super_death()
{
	new killer = read_data(1)
	
	if ( killer != g_super_player ) return
	
	if ( get_pcvar_num(pcvarHeal) )
	{
		new health = get_user_health(killer)
		set_user_health(killer, health + get_pcvar_num(pcvarHealPoints))
	}
}

public client_disconnect(id)
{
	if( id == g_super_player )
	{
		g_super_player = 0
	}
}

public client_infochanged(id)
{
	if( id == g_super_player && get_pcvar_num(pcvarPrefix) )
	{
		new oldname[32], newname[32]
		get_user_name(id, oldname, charsmax(oldname))
		get_user_info(id, "name", newname, charsmax(newname))
		
		if( !equal(oldname, newname) )
		{
			SetNamePrefix(id, newname)
		}
	}
}

public EventRoundStart()
{
	new players[32], num
	get_players(players, num, "a")
	
	if( num )
	{
		SetAbilities(players[random(num)])
	}
}

public EventRoundEnd()
{
	RemoveAbilities()
}

public FwdPlayerResetMaxSpeedPost(id)
{
	if( id == g_super_player )
	{
		set_user_maxspeed(id, get_pcvar_float(pcvarSpeed))
	}
}

SetAbilities(id)
{
	g_super_player = id;
	
	new name[32];
	get_user_name(id, name, charsmax(name))
	
	if ( get_pcvar_num(pcvarAnnounce) )
	{
		client_print(0, print_chat, "===> %s <=== A fost ales random [Super Player] - [200-Hp, 1-He ,2-Flash, 1-Smoke, Speed, Jump]", name)
	}
	
	if ( get_pcvar_num(pcvarPrefix) )
	{
		SetNamePrefix(id, name)
	}
	
	#if defined USE_SOUND
	emit_sound(id, CHAN_AUTO, gSound, VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
	#endif
	
	if ( get_pcvar_num(pcvarGiveHE) )
	{
		give_item(id, "weapon_hegrenade")
	}
	
	if ( get_pcvar_num(pcvarGiveSmoke) )
	{
		give_item(id, "weapon_smokegrenade")
	}
	
	if ( get_pcvar_num(pcvarGiveFlash) == 1 )
	{
		give_item(id, "weapon_flashbang")
	}
	
	else if ( get_pcvar_num(pcvarGiveFlash) == 2 )
	{
		give_item(id, "weapon_flashbang")
		give_item(id, "weapon_flashbang")
	}
	
	set_user_health(id, get_pcvar_num(pcvarHealth))
	set_user_armor(id, get_pcvar_num(pcvarArmor))
	set_user_maxspeed(id, get_pcvar_float(pcvarSpeed))
	set_user_gravity(id, get_pcvar_float(pcvarGrav))
}

RemoveAbilities()
{
	if( !g_super_player )
	{
		return
	}
	
	RemoveNamePrefix(g_super_player);
	
	g_super_player = 0
}

SetNamePrefix(id, name[32]="")
{
	if( !name[0] )
	{
		get_user_name(id, name, charsmax(name))
	}
	
	if( contain(name, g_name_prefix) )
	{
		format(name, charsmax(name), "%s%s", g_name_prefix, name)
		
		set_user_info(id, "name", name)
	}
}

RemoveNamePrefix(id)
{
	new name[32];
	get_user_name(id, name, charsmax(name))
	
	if( !contain(name, g_name_prefix) )
	{
		set_user_info(id, "name", name[charsmax(g_name_prefix)])
	}
}  
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1030\\ f0\\ fs16 \n\\ par }
*/
